/*
 * Copyright (c) 2007 Markus Fisch <mf@markusfisch.de>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of Markus Fisch nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */
#include "Utilities.h"

#include <sys/types.h>
#include <unistd.h>
#include <signal.h>
#include <libgen.h>
#include <iostream>

/**
 * Process entry
 *
 * @param argc - number of arguments
 * @param argv - pointer to pointers of arguments
 */
int main( int argc, char **argv )
{
	try
	{
		for( char *binary = *argv; --argc; )
			if( **++argv == '-' )
				switch( *((*argv)+1) )
				{
					default:
						std::cerr << "Skipping unknown flag '" <<
							*((*argv)+1) << "'" << std::endl;
						break;
					case 'l':
						PieDock::Utilities::listWindows();
						exit( 0 );
					case '?':
					case 'h':
						std::cout << 
							"usage: " << basename( binary ) << " [vhl]" << 
							std::endl << 
							"\t-v\tprint version and exit" << std::endl <<
							"\t-h\tshow this help and exit" << std::endl <<
							"\t-l\tlist windows and exit" << std::endl;
						exit( 0 );
					case 'v':
						std::cout << 
							basename( binary ) << " 0.0.4" << 
							" (c) 2007 Markus Fisch <mf@markusfisch.de>" << 
							std::endl;
						exit( 0 );
				}
			else
				std::cerr << "Skipping unknown argument \"" << 
					*argv << "\"" << std::endl;
	}
	catch( const char *e )
	{
		std::cerr << e << std::endl;

		return -1;
	}
}
